/****************************************************************************
** libmatroska : parse Matroska files, see http://www.matroska.org/
**
** <file/class description>
**
** Copyright (C) 2002-2003 Steve Lhomme.  All rights reserved.
**
** This file is part of libmatroska.
**
** This file may be distributed under the terms of the Q Public License
** as defined by Trolltech AS of Norway and appearing in the file
** LICENSE.QPL included in the packaging of this file.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** Licensees holding an other license may use this file in accordance with 
** the Agreement provided with the Software.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.matroska.org/license/qpl/ for QPL licensing information.
** See http://www.matroska.org/license/gpl/ for GPL licensing information.
**
** Contact license@matroska.org if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/

/*!
	\file
	\version \$Id: KaxInfo.cpp,v 1.4 2003/04/28 10:06:10 robux4 Exp $
	\author Steve Lhomme     <robux4 @ users.sf.net>
*/
#include "StdInclude.h"
#include "KaxInfo.h"
#include "KaxInfoData.h"

#include "KaxContexts.h"

// sub elements
START_LIBMATROSKA_NAMESPACE

const EbmlSemantic KaxInfo_ContextList[10] =
{
	EbmlSemantic(true, false, KaxSegmentUID::ClassInfos),
	EbmlSemantic(true, false, KaxSegmentFilename::ClassInfos),
	EbmlSemantic(true, false, KaxPrevUID::ClassInfos),
	EbmlSemantic(true, false, KaxPrevFilename::ClassInfos),
	EbmlSemantic(true, false, KaxNextUID::ClassInfos),
	EbmlSemantic(true, false, KaxNextFilename::ClassInfos),
	EbmlSemantic(true, false, KaxTimecodeScale::ClassInfos),
	EbmlSemantic(true, false, KaxDuration::ClassInfos),
	EbmlSemantic(true, false, KaxDateUTC::ClassInfos),
	EbmlSemantic(true, false, KaxTitle::ClassInfos),
};

const EbmlSemanticContext KaxInfo_Context = EbmlSemanticContext(countof(KaxInfo_ContextList), KaxInfo_ContextList, &KaxSegment_Context, *GetKaxGlobal_Context, &KaxInfo::ClassInfos);

EbmlId KaxInfo_TheId(0x1549A966, 4);
const EbmlCallbacks KaxInfo::ClassInfos(KaxInfo::Create, KaxInfo_TheId, "Info", KaxInfo_Context);

KaxInfo::KaxInfo()
	:EbmlMaster()
{
	Context = &KaxInfo_Context;
	ProcessMandatory();
}

END_LIBMATROSKA_NAMESPACE
