#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <string.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

/* Declares */
GtkWidget *main_window_widget, *open_filesel, *selected_input_file, *selected_input_file_widget;
gchar *mkvmerge_exe, *filename, *filename_mode;

/* Define the struct used to hold all the filenames and settings for each */
struct mkvmerge_input_files
{
  gchar *file;
  gint video_stream;
  gint audio_stream;
  gchar *fourcc;
  gboolean fourcc_checked;
};
struct mkvmerge_input_files current_input_files[255];
gint last_file = 0;

void
on_ok_buttonFileDialog_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *des_text;
  GtkWidget *gtklist, *label;
  GtkWidget *list_item, *video_options, *audio_options, *fourcc, *checkbutton_fourcc, *output_file;

  gchar *config_file, *mkvmerge_label_txt, *output_file_txt;
  int opened_file;

  /* Extract filename from the file selection dialog */
  filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(open_filesel));
  
  /* Find out if we are getting the input file name or the output filename */
  if (filename_mode == "input")
  {
    des_text = lookup_widget (main_window_widget, "list_input_files");
    video_options = lookup_widget (main_window_widget, "optionmenu_video");
    audio_options = lookup_widget (main_window_widget, "optionmenu_audio");
    fourcc = lookup_widget (main_window_widget, "combo_entry_fourcc");
    checkbutton_fourcc = lookup_widget (main_window_widget, "checkbutton_fourcc");
    
    last_file++;
    current_input_files[last_file].file = (char *)malloc(strlen(filename));
    strcpy(current_input_files[last_file].file, filename);
    current_input_files[last_file].video_stream = gtk_option_menu_get_history (GTK_OPTION_MENU(video_options)) - 1;
    current_input_files[last_file].audio_stream = gtk_option_menu_get_history (GTK_OPTION_MENU(audio_options)) - 1;

    current_input_files[last_file].fourcc = (char *)malloc(strlen(gtk_entry_get_text (GTK_ENTRY(fourcc))));
    strcpy(current_input_files[last_file].fourcc, gtk_entry_get_text (GTK_ENTRY(fourcc)));

    current_input_files[last_file].fourcc_checked = gtk_toggle_button_get_active (checkbutton_fourcc);

    /* Create a new label to place in the list */
    label = gtk_label_new(current_input_files[last_file].file);
    gtk_object_set_data (GTK_OBJECT (label), "number", last_file);

    gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
    gtk_label_set_line_wrap (GTK_LABEL (label), TRUE);
    gtk_widget_set_usize (label, 992, NULL);
    /* Create a new list item to contain the label */
    list_item = gtk_list_item_new();

    gtk_widget_ref (label);
    gtk_object_set_data_full (GTK_OBJECT (list_item), "label", label,
                            (GtkDestroyNotify) gtk_widget_unref);
    //gtk_object_set_data (GTK_OBJECT (list_item), "label", label);

    gtk_widget_set_usize (list_item, 992, NULL);
    /* Place the label inside the list item */
    gtk_container_add (GTK_CONTAINER(list_item), label);
    /* Display the label */
    gtk_widget_show (label);
    /* Add the list item to the list */
    gtk_container_add (GTK_CONTAINER(GTK_LIST(des_text)), list_item);
    /* Display the list item */
    gtk_widget_show (list_item);
    
    /* Copy to the ouput file box if blank */
    output_file = lookup_widget (GTK_WIDGET (main_window_widget), "entry_output_file");
    if (strlen(gtk_entry_get_text (GTK_ENTRY(output_file))) <= 1)
    {
      output_file_txt = merge_strings(filename, ".mkv");
      gtk_entry_set_text (GTK_ENTRY(output_file), output_file_txt);
    }
  }
  if (filename_mode == "output")
  {
      des_text = lookup_widget (main_window_widget, "entry_output_file");
      /* Place the filename in the text box */
      gtk_entry_set_text (GTK_ENTRY(des_text), filename);
  }
  if (filename_mode == "mkvmerge_exe")
  {
      mkvmerge_exe = filename;
      config_file = "mkvmerge-gui.cfg";
      opened_file = g_io_channel_new_file(config_file,"w", NULL);
      g_io_channel_write_chars (opened_file, mkvmerge_exe, -1, NULL, NULL);
      //g_io_channel_shutdown (opened_file, TRUE, NULL);
      update_label_mkvmerge ();
   }
  if (filename_mode == "mkvmerge_exe_setup")
  {
      mkvmerge_exe = filename;
      config_file = "mkvmerge-gui.cfg";
      opened_file = g_io_channel_new_file(config_file,"w", NULL);
      g_io_channel_write_chars (opened_file, mkvmerge_exe, -1, NULL, NULL);
      //g_io_channel_shutdown (opened_file, TRUE, NULL);

      /* Update the mkvmerge.exe location status label */
      des_text = lookup_widget (main_window_widget, "label_mkvmerge");
      mkvmerge_label_txt = merge_strings("mkvmerge exe: ", mkvmerge_exe);
      gtk_label_set_text(GTK_LABEL(des_text), mkvmerge_label_txt);
      update_label_mkvmerge ();
  }
   
  /* Reset the filename mode since we are done with it */
  filename_mode = "done";
}

void
on_cancel_buttonFileDialog_clicked     (GtkButton       *button,
                                        gpointer         user_data)
{
  /* This is already connected to the gtk_widget_destroy */
}


void
on_window_about_destroy                (GtkObject       *object,
                                        gpointer         user_data)
{
  /* This window is already connected to gtk_widget_destroy */
  gtk_grab_remove(object);
}

void
on_button_show_about_clicked           (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *window_about, *local_button_Okay;
  /* Create the About Dialog */
  window_about = create_window_about ();
  /* Connect the Ok button in the About dialog to the gtk_widget_destroy */
  local_button_Okay = lookup_widget (window_about, "button_Okay");
  gtk_signal_connect_object(GTK_OBJECT (local_button_Okay), "clicked", gtk_widget_destroy, GTK_OBJECT(window_about));
  /* Show the About Dialog */
  gtk_widget_show (window_about);
  gtk_grab_add(window_about);
}


/* Code */
void usage(void)
{
  g_print(
  "mkvmerge -o out [global options] [options] <file1> [[options] <file2> ...]"
    "\n\n Global options:\n"
    "  -v, --verbose            verbose status\n"
    "  -q, --quiet              suppress status output\n"
    "  -o, --output out         Write to the file 'out'.\n"
    " --cluster-length <n[ms]>  Put at most n data blocks into each cluster.\n"
    "                           If the number is postfixed with 'ms' then\n"
    "                           put at most n milliseconds of data into each\n"
    "                           cluster.\n"
    "\n Options for each input file:\n"
    "  -a, --astreams <n,m,...> Copy the n'th audio stream, NOT the stream with"
  "\n                           the serial number n. Default: copy all audio\n"
    "                           streams.\n"
    "  -d, --vstreams <n,m,...> Copy the n'th video stream, NOT the stream with"
  "\n                           the serial number n. Default: copy all video\n"
    "                           streams.\n"
//     "  -t, --tstreams <n,m,...> Copy the n'th text stream, NOT the stream with"
//   "\n                           the serial number n. Default: copy all text\n"
//     "                           streams.\n"
    "  -A, --noaudio            Don't copy any audio stream from this file.\n"
    "  -D, --novideo            Don't copy any video stream from this file.\n"
//     "  -T, --notext             Don't copy any text stream from this file.\n"
    "  -s, --sync <d[,o[/p]]>   Ssynchronize, delay the audio stream by d ms.\n"
    "                           d > 0: Pad with silent samples.\n"
    "                           d < 0: Remove samples from the beginning.\n"
    "                           o/p: Adjust the timestamps by o/p to fix\n"
    "                           linear drifts. p defaults to 1000 if\n"
    "                           omitted. Both o and p can be floating point\n"
    "                           numbers.\n"
    "  -f, --fourcc <FOURCC>    Forces the FourCC to the specified value.\n"
    "                           Works only for video streams.\n"
    "\n"
    " Other options:\n"
    "  -l, --list-types         Lists supported input file types.\n"
    "  -h, --help               Show this help.\n"
    "  -V, --version            Show version information.\n"
  );
};

void run_mkvmerge()
{
  /* For creation of command-line to run */
  GtkWidget *output_file_entry;
  gchar *output_file_txt;
  gchar *mkvmerge_command_line, *formatbuffer;
  GError *command_error = NULL;
  gchar *standard_output;
  gint loop, selected_stream;

  /* Create the command-line for launching  */
  mkvmerge_command_line = "\"";
  mkvmerge_command_line = merge_strings(mkvmerge_command_line, mkvmerge_exe);
  mkvmerge_command_line = merge_strings(mkvmerge_command_line, "\" -v ");

  /* Add the output file */
  mkvmerge_command_line = merge_strings(mkvmerge_command_line, " -o \"");
  /* Retrive the output file text */
  output_file_entry = lookup_widget (GTK_WIDGET (main_window_widget), "entry_output_file");  
  output_file_txt = gtk_entry_get_text (GTK_ENTRY(output_file_entry));
  mkvmerge_command_line = merge_strings(mkvmerge_command_line, output_file_txt);
  mkvmerge_command_line = merge_strings(mkvmerge_command_line, "\" ");
  
  /* Add the input files */
  for(loop=1;loop<=last_file;loop++)
  {
    g_print("file %i ",loop);
    g_print("video stream %i \n", current_input_files[loop].video_stream);
    switch (current_input_files[loop].video_stream)
    {
      case -1:
        /* Do nothing because all streams were selected */
        break;      
      case 0:
        /* No streams were selected */
        mkvmerge_command_line = merge_strings(mkvmerge_command_line, " --novideo ");
        break;
      default:
      {
        mkvmerge_command_line = merge_strings(mkvmerge_command_line, " --vstreams ");
        formatbuffer = (char *)malloc(strlen("%i "));
        g_snprintf(formatbuffer, "%i", current_input_files[loop].video_stream + 2);
        mkvmerge_command_line = merge_strings(mkvmerge_command_line, formatbuffer);
        break;
      }
    }
    switch (current_input_files[loop].audio_stream)
    {
      case -1:
        /* Do nothing because all streams were selected */
        break;
      case 0:
        /* No streams were selected */
        mkvmerge_command_line = merge_strings(mkvmerge_command_line, " --noaudio ");
        break;
      default:
      {
        mkvmerge_command_line = merge_strings(mkvmerge_command_line, " --astreams ");
        formatbuffer = (char *)malloc(strlen("%i "));
        g_snprintf(formatbuffer,"%i", current_input_files[loop].audio_stream + 2);
        mkvmerge_command_line = merge_strings(mkvmerge_command_line, formatbuffer);
        break;
      }
    }
    if (current_input_files[loop].fourcc_checked)
    {
      mkvmerge_command_line = merge_strings(mkvmerge_command_line, " --fourcc ");
      mkvmerge_command_line = merge_strings(mkvmerge_command_line, current_input_files[loop].fourcc);
      mkvmerge_command_line = merge_strings(mkvmerge_command_line, " ");
    };
    mkvmerge_command_line = merge_strings(mkvmerge_command_line, "\"");
    mkvmerge_command_line = merge_strings(mkvmerge_command_line, current_input_files[loop].file);
    mkvmerge_command_line = merge_strings(mkvmerge_command_line, "\" ");

  };
  g_spawn_command_line_sync(mkvmerge_command_line, &standard_output, NULL, NULL, NULL);

  g_print("\nThe Command-line Passed\n");
  g_print(mkvmerge_command_line);
  g_print("\nThe Result\n");
  g_print(standard_output);

};

void check_location ()
{
  gchar *config_file;
  gchar *config_read;
  int opened_file;
  int *l_open_file;

  mkvmerge_exe = "not set";
  config_file = "mkvmerge-gui.cfg";
  /* Open the cfg file */
  opened_file = g_io_channel_new_file(config_file,"r+", NULL);
  /* Check if it doesn't exist */
  if (opened_file == NULL)
  {
    /* It failed to open, most likely it doesn't exist */
    filename_mode = "mkvmerge_exe";
    /* Ask the user to locate the mkvmerge */
    open_file("Please locate the mkvmerge","","");
  }
  else
  {
    /* Ok, It opened correctly. Now Lets read it */
    g_io_channel_read_line (opened_file, &config_read, NULL, l_open_file, NULL);
    /* Store the mkvmerge.exe path+name to the global var */
    mkvmerge_exe = config_read;
  }
};

gchar *merge_strings (gchar *first_string, gchar *second_string)
{
  /* Thanks to mosu for this little snippet of code */
  gchar *newstring;

  /* Allocate enough memory to hold both strings */
  newstring = (char *)malloc(strlen(first_string) + strlen(second_string) + 1);
  /* Copy the first string to a new string */
  strcpy(newstring, first_string);
  /* Copy the second string on the end of the new string */
  strcat(newstring, second_string);

  /* Return the new string */
  return newstring;
};

char *strip_ext(char *filename_to_strip)
{
  char *new_filename, *old_filename;
  int len_without_ext;

  old_filename = filename_to_strip;
  new_filename = filename_to_strip;
  old_filename = strrchr(old_filename, '.');
  len_without_ext = strlen(new_filename) - strlen(old_filename);
  g_print("Len without ext \n%i\n", len_without_ext);
  new_filename = malloc(len_without_ext);
  g_print(new_filename);
  new_filename = strncpy(new_filename, old_filename, len_without_ext);
  //char *strchr(const char *str, int c);
  return new_filename;
};

void
open_file (gchar *file_dialog_text, gchar *pattern, gchar *target_filename)
{
  //GtkWidget *fileselection1;
  GtkWidget *ok_buttonFileDialog;
  GtkWidget *cancel_buttonFileDialog;

  /* Create file selection widget so we can use it */
  open_filesel = gtk_file_selection_new (file_dialog_text);
  /* Set the data for the file selection widget so we can look it up easily */
  gtk_object_set_data (GTK_OBJECT (open_filesel), "open_filesel", open_filesel);
  gtk_container_set_border_width (GTK_CONTAINER (open_filesel), 10);
  GTK_WINDOW (open_filesel)->type = GTK_WINDOW_TOPLEVEL;

  /* Set the file pattern */
  if (pattern != "")
  {
    gtk_file_selection_complete (open_filesel, pattern);
  }
  gtk_file_selection_set_filename (open_filesel, target_filename);
  /* Create the ok button */
  ok_buttonFileDialog = GTK_FILE_SELECTION (open_filesel)->ok_button;
  /* Set the data for the ok button widget so we can look it up easily */
  gtk_object_set_data (GTK_OBJECT (open_filesel), "ok_buttonFileDialog", ok_buttonFileDialog);
  gtk_widget_show (ok_buttonFileDialog);
  GTK_WIDGET_SET_FLAGS (ok_buttonFileDialog, GTK_CAN_DEFAULT);

  /* Create the cancel button */
  cancel_buttonFileDialog = GTK_FILE_SELECTION (open_filesel)->cancel_button;
  /* Set the data for the cancel button widget so we can look it up easily */
  gtk_object_set_data (GTK_OBJECT (open_filesel), "cancel_buttonFileDialog", cancel_buttonFileDialog);
  gtk_widget_show (cancel_buttonFileDialog);
  GTK_WIDGET_SET_FLAGS (cancel_buttonFileDialog, GTK_CAN_DEFAULT);

  /* Connect the buttons to the event functions */
  gtk_signal_connect (GTK_OBJECT (ok_buttonFileDialog), "clicked",
                      GTK_SIGNAL_FUNC (on_ok_buttonFileDialog_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cancel_buttonFileDialog), "clicked",
                      GTK_SIGNAL_FUNC (on_cancel_buttonFileDialog_clicked),
                      NULL);
  /* Connect the cancel button to the file selection widget destroy, so the window will close */
  gtk_signal_connect_object(GTK_OBJECT (cancel_buttonFileDialog), "clicked", gtk_widget_destroy, GTK_OBJECT(open_filesel));
  /* Connect the ok button to the file selection widget destroy, so the window will close */
  gtk_signal_connect_object(GTK_OBJECT (ok_buttonFileDialog), "clicked", gtk_widget_destroy, GTK_OBJECT(open_filesel));

  /* Display the file selection dialog */
  gtk_widget_show (open_filesel);
  /* Raise it to the top window */
  gdk_window_raise (open_filesel->window);

  //open_filesel = fileselection1;
}

void
on_window_mkvmerge_gui_destroy         (GtkObject       *object,
                                        gpointer         user_data)
{
  /* Exit the program */
  gtk_main_quit();
}


void
on_button_add_input_file_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  main_window_widget = lookup_widget (GTK_WIDGET (button), "window_mkvmerge_gui");

  filename_mode = "input";
  open_file("Locate Input File","", filename);
}


void
on_button_exit_program_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  /* Exit the program */
  gtk_main_quit();
}


void
on_button_update_entry_clicked         (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *input_list, *input_file_edit;
  gchar *label_txt;
  gint selected_item;

  /* Find the currently selected input file */
  input_list = lookup_widget (GTK_WIDGET (button), "list_input_files");
  selected_item = gtk_list_child_position (GTK_LIST(input_list), selected_input_file_widget);

  input_file_edit = lookup_widget (GTK_WIDGET (button), "entry_selected_input_file");
  current_input_files[selected_item + 1].file = (char *)malloc(strlen(gtk_entry_get_text (GTK_ENTRY(input_file_edit))));
  strcpy(current_input_files[selected_item + 1].file, gtk_entry_get_text (GTK_ENTRY(input_file_edit)));

  label_txt = (char *)malloc(strlen(gtk_entry_get_text (GTK_ENTRY(input_file_edit))));
  strcpy(label_txt, gtk_entry_get_text (GTK_ENTRY(input_file_edit)));

  gtk_label_set(selected_input_file, label_txt);

}


void
on_button_del_input_file_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *input_list;
  gint selected_item, loop;
  
  input_list = lookup_widget (GTK_WIDGET (button), "list_input_files");
  selected_item = gtk_list_child_position (GTK_LIST(input_list), selected_input_file_widget);

  //g_print("%i",selected_item);
  gtk_list_clear_items (input_list, (selected_item), (selected_item + 1));
  for(loop=last_file;loop=1;loop--)
  {
    g_print("%i \n",loop);
    /*current_input_files[last_file].file = (char *)malloc(strlen(filename));
    strcpy(current_input_files[last_file].file, filename);
    current_input_files[last_file].video_stream = gtk_option_menu_get_history (GTK_OPTION_MENU(video_options)) - 1;
    current_input_files[last_file].audio_stream = gtk_option_menu_get_history (GTK_OPTION_MENU(audio_options)) - 1;

    current_input_files[last_file].fourcc = (char *)malloc(strlen(gtk_entry_get_text (GTK_ENTRY(fourcc))));
    strcpy(current_input_files[last_file].fourcc, gtk_entry_get_text (GTK_ENTRY(fourcc)));

    current_input_files[last_file].fourcc_checked = gtk_toggle_button_get_active (checkbutton_fourcc);

    current_input_files[last_file].label_txt = label; */
  }
  last_file--;
}


void
on_list_input_files_select_child       (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
  GtkWidget *label_widget, *optionmenu_widget, *optionmenu_menu_video, *optionmenu_menu_audio, *glade_menuitem, *fourcc, *checkbutton_fourcc, *input_file_edit;
  GList *container_children_list, *widget_list;
  gint selected_input_file_number;
  gchar *label_txt;

  /* Store the container that is holding the label in the list */
  selected_input_file_widget = widget;

  /* Get the list of widgets/children in the container */
  container_children_list = gtk_container_children (GTK_CONTAINER(widget));
  /* Grab the first one. Well there should only be one anyway */
  widget_list = g_list_first (container_children_list);
  /* Store the pointer to the label widget */
  label_widget = widget_list->data;

  /* Store the found label widget */
  selected_input_file = label_widget;

  /* Get the number of the selected list item */
  selected_input_file_number = gtk_list_child_position (GTK_LIST(list), selected_input_file_widget);

  /* Put the filename in the input file edit box */
  /* Lookup the input file edit box */
  input_file_edit = lookup_widget (GTK_WIDGET (main_window_widget), "entry_selected_input_file");
  /* Get the filename */
  gtk_label_get(selected_input_file, &label_txt);
  /* Place in the input file edit box */
  gtk_entry_set_text(GTK_ENTRY(input_file_edit), label_txt);

  /* Create the menu list used for video stream selection */
  optionmenu_menu_video = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label ("All");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("None");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("1");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("2");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("3");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("4");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("5");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("6");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("7");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("8");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("9");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_video), glade_menuitem);

  /* Get the widget of the video stream option menu */
  optionmenu_widget = lookup_widget (GTK_WIDGET (main_window_widget), "optionmenu_video");
  /* Reload the menu choices */
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu_widget), optionmenu_menu_video);
  /* Display the selected video stream selection */
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu_widget), current_input_files[selected_input_file_number + 1].video_stream + 1);
  
    /* Create the menu list used for audio stream selection */
  optionmenu_menu_audio = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label ("All");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("None");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("1");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("2");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("3");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("4");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("5");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("6");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("7");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("8");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label ("9");
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_menu_audio), glade_menuitem);

  /* Get the widget of the audio stream option menu */
  optionmenu_widget = lookup_widget (GTK_WIDGET (main_window_widget), "optionmenu_audio");
  /* Reload the menu choices */
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu_widget), optionmenu_menu_audio);
  /* Display the selected audio stream selection */
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu_widget), current_input_files[selected_input_file_number + 1].audio_stream + 1);

  /* Lookup the fourcc checkbox */
  checkbutton_fourcc = lookup_widget (main_window_widget, "checkbutton_fourcc");
  gtk_toggle_button_set_active (checkbutton_fourcc, current_input_files[selected_input_file_number + 1].fourcc_checked);

  /* Lookup the fourcc entry box */
  fourcc = lookup_widget (main_window_widget, "combo_entry_fourcc");
  /* Set the fourcc */
  gtk_entry_set_text (GTK_ENTRY(fourcc), current_input_files[selected_input_file_number + 1].fourcc);

}


void
on_button_start_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  run_mkvmerge();
}


void
on_optionmenu_video_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  /* This never gets called for some reason??? */

}


void
on_optionmenu_audio_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{
  GtkWidget *input_list, *audio_stream_option;
  gint selected_item;

  /* Find the currently selected input file */
  input_list = lookup_widget (GTK_WIDGET (button), "list_input_files");
  selected_item = gtk_list_child_position (GTK_LIST(input_list), selected_input_file_widget);

  /* Get the selected choice for streams and store it in the correct record */
  audio_stream_option = lookup_widget (GTK_WIDGET (button), "optionmenu_audio");
  current_input_files[selected_item + 1].audio_stream = gtk_option_menu_get_history (GTK_OPTION_MENU (audio_stream_option)) - 1;

}


void
on_combo_entry_fourcc_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{
  GtkWidget *input_list;
  gint selected_item;

  /* Find the currently selected input file */
  input_list = lookup_widget (GTK_WIDGET (editable), "list_input_files");
  selected_item = gtk_list_child_position (GTK_LIST(input_list), selected_input_file_widget);

  current_input_files[selected_item + 1].fourcc = (char *)malloc(strlen(gtk_entry_get_text (GTK_ENTRY(editable))));
  strcpy(current_input_files[selected_item + 1].fourcc, gtk_entry_get_text (GTK_ENTRY(editable)));
}

void
on_button_output_file_browse_clicked   (GtkButton       *button,
                                        gpointer         user_data)
{
  main_window_widget = lookup_widget (GTK_WIDGET (button), "window_mkvmerge_gui");

  filename_mode = "output";
  open_file("Locate Matroska Output File","*.mkv",filename);
}


void
on_checkbutton_fourcc_toggled          (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  GtkWidget *input_list;
  gint selected_item;

  /* Find the currently selected input file */
  input_list = lookup_widget (GTK_WIDGET (togglebutton), "list_input_files");
  selected_item = gtk_list_child_position (GTK_LIST(input_list), selected_input_file_widget);

  current_input_files[selected_item + 1].fourcc_checked = gtk_toggle_button_get_active (togglebutton);
}

gboolean
on_optionmenu_video_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  GtkWidget *input_list, *video_stream_option;
  gint selected_item;

  /* Find the currently selected input file */
  input_list = lookup_widget (GTK_WIDGET (widget), "list_input_files");
  selected_item = gtk_list_child_position (GTK_LIST(input_list), selected_input_file_widget);

  if (selected_item >= 0)
  {
    /* Get the selected choice for streams and store it in the correct record */
    video_stream_option = lookup_widget (GTK_WIDGET (widget), "optionmenu_video");
    current_input_files[selected_item + 1].video_stream = gtk_option_menu_get_history (GTK_OPTION_MENU (video_stream_option)) - 1;
  }
  return FALSE;
}

gboolean
on_optionmenu_audio_event              (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  GtkWidget *input_list, *audio_stream_option;
  gint selected_item;

  /* Find the currently selected input file */
  input_list = lookup_widget (GTK_WIDGET (widget), "list_input_files");
  selected_item = gtk_list_child_position (GTK_LIST(input_list), selected_input_file_widget);

  if (selected_item >= 0)
  {
    /* Get the selected choice for streams and store it in the correct record */
    audio_stream_option = lookup_widget (GTK_WIDGET (widget), "optionmenu_audio");
    current_input_files[selected_item + 1].audio_stream = gtk_option_menu_get_history (GTK_OPTION_MENU (audio_stream_option)) - 1;
  }
  return FALSE;
}

void
on_button_mkvmerge_setup_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
  filename_mode = "mkvmerge_exe_setup";
  open_file("Please locate the mpa2mka.exe","",mkvmerge_exe);
}


void update_label_mkvmerge ()
{
  GtkWidget *label_widget;
  gchar *mkvmerge_exe_label_txt;

  label_widget = lookup_widget(main_window_widget,"label_mkvmerge");
  if (mkvmerge_exe != NULL)
  {
    mkvmerge_exe_label_txt = merge_strings("mpa2mka exe: ", mkvmerge_exe);
    gtk_label_set_text(GTK_LABEL(label_widget), mkvmerge_exe_label_txt);
  }
}

